# Figures Documentation
You can Find almost every file you need in the Figures folder. 
First run the **initial.sh** script to create the folders you need.
## initial.sh
This is a script that is run in the beginning of all the scripts to make sure you have the appropriate directories.
It is recommended to run this before you start creating the figures.

## Advection_test.sh
This file creates the stream line figure for the ./example_scripts/**periodic_advection_test**.sh
So make sure to run that script first. It creates the figures for 7 cases described in periodic_advection_test.sh.
The template tex file for this script is located in the same folder as the script and is called **advection_test.tex**
The corresponding figure would be figure 5 in consistent paper.
<br/>
_Note:_ run this script from the same folder of your output directory.
## curvature.sh
This file creates a jpg file named curvature.jpg in the same directory you're running it from. This plot is a 3D scatter plot of curvature values in the sim you ran. Currently it uses the output directory of steady_drop sim. Which can be run using ./example_scripts/**steady_drop**.sh
It first runs a cpp file to get the curvature data in a txt file and then passes the data to the octave script(curvature.m).
There is no corresponding figure for this in the consistent paper.
## steady_error.sh
This script creates two figures for the steady drop test(./example_scripts/**steady_drop.sh**)
The two figures show the L2 and Linf error of the simulation in the last frame.The corresponding figure would be **figure 8** in consistent paper.
There are two functions in the script. The first one calls the cpp function to make the data and the second one changes the tex file so that it reflects the right data files.
The corresponding tex file for this script is **steady_error.tex**
## surface_snapshot.sh
This script takes snapshots of the sim. It corresponds to figures **17,18,19,21,22,23,24,25,26** in the consistent paper.
It corresponds to **./example_scripts/rayleigh-taylor_test.sh,dam_break_test.sh** and could be used with **air_bubble_test.sh** 

<span style="color:red"> *Note:* </span> if you want to change the colors in the figure you have to change the .cpp and .text file. both are located in chns_project folder. The default is yellow and white.

## <span style="color:yellowgreen"> sim2fig.sh </span> 
This script creates 4 figures and the data for **air_bubble_table.sh** so make sure you run it before running air_bubble_table.sh.
The script creates the circularity, rising velocity, center of mass and surface figure which correspond to **Fig 11,12,13** in consistent paper.
you can repurpose this script to make the reference data for the air_bubble_table too.
The script itself corresponds to **example_scripts/air_bubble_test.sh**.\
This script takes a bit longer to run because it goes over every frame of every sim. The corresponding tex file for this script is **sim2fig.tex**
## <span style="color:yellowgreen"> air_bubble_table.sh </span> 
This scripts creates the table containg error and orders of different air bubble sims. The corresponding table in consistent paper is **Table 8**.\
This script and sim2fig.sh are intertwined. so make sure to run sim2.fig properly fist before runnign this script. You should also create the reference files for error computations using sim2fig. There is one line for each of 6 cases in this script that need to be run to create the reference files. make sure to uncomment them.\
This script corresponds to two tex files. 
**air_bubble_table** has the structure needed for a tex file to become pdf. So you can use pdflatex on this file and templates created from this file.
However, **air_bubble_table_temp** just has the structure of the table and unless it's included in another tex file (e.g paper) it cannot be converted to pdf. So use the first one if you want to see the pdf first and use the second if you want to make tha table and include it in the paper.