#!/bin/bash
#===================================================================
# August 2023 Jason Goulding
# Creates the plot of g(gamma)
#===================================================================
basedir="$PROJ/chns_project"
ex="$basedir/example_scripts"
sc="$basedir/Figures/scripts"

fig="$1"
mkdir -p $fig/logs $fig/tex $fig/txt $fig/pdfs
shift

cp "$sc/g_func_header.tex" "$fig/tex/g_func_plot.tex"
outputfile="$fig/tex/g_func_plot.tex"

relativepath=$(realpath --relative-to=./ $fig/tex)

gnuplot -c $sc/g_function_plot.gp $relativepath/g_func.tex

cat $relativepath/g_func.tex >> $outputfile
echo '\end{document}' >> $outputfile
pdflatex -halt-on-error -output-directory=$fig/pdfs $outputfile

cp $fig/pdfs/g_func_plot.pdf $fig




