#!/usr/bin/perl -w

require strict;

my $small=1e-8;

my @name=();
my %Ai=();
my %A2=();
my @ref=();

for my $f (@ARGV)
{
    my $refine=0;
    my %hi=();
    my %h2=();
    open F, "$f";
    while(<F>)
    {
        if(/command = .*-refine\s+(\S+)/)
        {
            $refine=$1+0;
        }
        if(/L2\s+error\s+\((.*)\)\s+at\s+time\s+(.*)\s+:\s+(.*)\s+max\s+abs\s+error:\s+(.*)/)
        {
            if(!defined $Ai{$1})
            {
                push @name,$1;
                $Ai{$1}=[];
                $A2{$1}=[];
            }
            $h2{$1}=$3+0;
            $hi{$1}=$4+0;
        }
    }
    my @k=sort keys %hi;
    push @ref, $refine;
    for(keys %hi)
    {
        push @{$Ai{$_}}, $hi{$_};
        push @{$A2{$_}}, $h2{$_};
    }
    close F;
}

sub rate
{
    my $r=$_[0];
    my $a=$_[1];
    my @r=@$r;
    my @a=@$a;
    @a=map{log($_)} @a;
    @r=map{-log($_)} @r;
    my $n=@r;
    my $sr=0;
    my $sx=0;
    my $sr2=0;
    my $srx=0;
    for(my $i=0;$i<$n;$i++)
    {
        $sr+=$r[$i];
        $sx+=$a[$i];
        $sr2+=$r[$i]*$r[$i];
        $srx+=$a[$i]*$r[$i];
    }
    my $c=($n*$srx-$sr*$sx)/($n*$sr2-$sr*$sr);
    printf("% 0.2f",$c);
}

for my $n (@name)
{
    my $ai=$Ai{$n};
    my @ai=@$ai;
    my $a2=$A2{$n};
    my @a2=@$a2;
    my $is_small2=1;
    my $is_smalli=1;
    my $has_zero2=0;
    my $has_zeroi=0;
    for(@a2){if($_>$small){$is_small2=0;}if($_<=0){$has_zero2=1;}}
    for(@ai){if($_>$small){$is_smalli=0;}if($_<=0){$has_zeroi=1;}}

    printf("%-25s    L2 ",$n);
    if($has_zero2){print "  ZZ ";}
    else{&rate(\@ref,$A2{$n});}
    if($is_small2){print " S ";}
    else{print "   ";}
    print "  Linf ";
    if($has_zero2){print "  ZZ ";}
    else{&rate(\@ref,$Ai{$n});}
    if($is_smalli){print " S ";}
    else{print "   ";}
    
    print "    data (inf): @ai     data (L2): @a2\n";
}


