#! /usr/bin/env bash
basedir="$PROJ/chns_project"
ex="$basedir/example_scripts"
sc="$basedir/Figures/scripts"

fig="$1"
mkdir -p $fig/logs $fig/tex $fig/txt $fig/pdfs
shift

test=${1:-0}
end_frame=100
dt=0.01
cfl=0.5
sigma="1e-12"
eta=0.0234375
M="1e-7"
option=$2
# use_out=$3

rm -f $fig/tmp-*txt

CMD="$basedir/chns -test 15 -frame_dt $dt -e $end_frame $option -second_order -sigma $sigma -eta $eta -M $M -mu0 0 -mu1 0 -tol 1e-12 "

# density ratio 1, periodic
if [ $test -eq 0 ]
then
    refine=16
    $CMD -rho0 1 -rho1 1 -res 8 -refine $refine -periodic_v "1 1" -o $fig/basic_ch_periodic_$test
# density ratio 10, periodic
elif [ $test -eq 1 ]
then    
    refine=16
    $CMD -rho0 1 -rho1 10 -res 8 -refine $refine -periodic_v "1 1" -o $fig/basic_ch_periodic_$test
# density ratio 100, periodic
elif [ $test -eq 2 ]
then    
    refine=16
    $CMD -rho0 1 -rho1 100 -res 8 -refine $refine -periodic_v "1 1" -o $fig/basic_ch_periodic_$test
# density ratio 1000, periodic
elif [ $test -eq 3 ]
then    
    refine=16
    $CMD -rho0 1 -rho1 1000 -res 8 -refine $refine -periodic_v "1 1" -o $fig/basic_ch_periodic_$test
# density ratio 10000, periodic
elif [ $test -eq 4 ]
then    
    refine=16
    $CMD -rho0 1 -rho1 10000 -res 8 -refine $refine -periodic_v "1 1" -o $fig/basic_ch_periodic_$test
# density ratio 1000, periodic
elif [ $test -eq 30 ]
then    
    refine=16
    $CMD -rho0 1 -rho1 1000 -res 8 -refine $refine -range_scale "0 3" -periodic_v "1 1" -o $fig/basic_ch_periodic_$test
fi
