#! /usr/bin/env bash
#========================================================
# By default, runs a droplet test at a density ratio of approximately 1000 (water/air)
# Usage: droplet_test.sh <fig> [optional argument=none]
#========================================================
basedir="$PROJ/chns_project"
ex="$basedir/example_scripts"
sc="$basedir/Figures/scripts"

fig="$1"
mkdir -p $fig/logs $fig/tex $fig/txt $fig/pdfs
shift

test=${1:-0}
end_frame=1000
dt=0.01
option=$2
eta=0.01 # could be different
steps=20
M=0 # chosen so that program automatically calculates M such that L*M=1e-7
# M="1e-3"
refine=16
# M0=$(perl -e 'print 10**(-5)')
# eta0=$(perl -e 'print 1/32')
# h=$(perl -e 'print 4/(16*'$refine')')
# h0=$(perl -e 'print 1/32')
# Xeta=$(perl -e 'print 2/3')
# XM=$(perl -e 'print 3/2')
# eta=$(perl -e 'print '$eta0'*('$h'/'$h0')**'$Xeta)
# M=$(perl -e 'print '$M0'*('$eta'/'$eta0')**'$XM)

CMD="$basedir/chns -test 24 -frame_dt $dt -e $end_frame $option -second_order -mu0 1.78e-5 -mu1 1.002e-3 -ch_sigma 7.28e-2 -ch_eta $eta -st_type 2 -ch_h_tol 1e-12 -mu_tol 1e-12 -p_tol 1e-12 "

if [ $test -eq 0 ]
then
    echo $CMD -ch_M $M -rho0 1.204 -rho1 998.207 -range_max "1 1" -res_v "8 8" -spf $steps -refine $refine -gravity_v "0 -9.8" -o $fig/droplet_test_"$test"
    $CMD -ch_M $M -rho0 1.204 -rho1 998.207 -range_max "1 1" -res_v "8 8" -spf $steps -refine $refine -gravity_v "0 -9.8" -o $fig/droplet_test_"$test" >/dev/null
elif [ $test -eq 1 ]
then
    M="1e-2"
    steps=40
    echo $CMD -ch_M $M -rho0 1.204 -rho1 998.207 -range_max "1 1" -res_v "8 8" -spf $steps -refine $refine -gravity_v "0 -9.8" -o $fig/droplet_test_"$test"
    $CMD -ch_M $M -rho0 1.204 -rho1 998.207 -range_max "1 1" -res_v "8 8" -spf $steps -refine $refine -gravity_v "0 -9.8" -o $fig/droplet_test_"$test" >/dev/null
fi

