#!/bin/bash
basedir="$PROJ/chns_project"
ex="$basedir/example_scripts"
sc="$basedir/Figures/scripts"

fig="$1"
mkdir -p $fig/logs $fig/tex $fig/txt $fig/pdfs
shift

MAX=160
FULL=1

RES="`seq 8 8 $MAX`"

if [ "X$FULL" = "X1" ] ; then
    (
        rm -f $fig/txt/linear_stab_logs/
        mkdir $fig/txt/linear_stab_logs/
        for r in $RES ; do
            binary_search --token TT --pass=1e-12 --fail=1 --width=1e-4 --pat_fail='gamma.*max=[2-9]' -- $basedir/chns -test 5 -no_adv -no_st_force -no_viscosity -ch_linear -res $r -ch_eta 0.01 -ch_M 0.001 -ch_sigma 0.09428 -gamma 0 -second_order -range_scale "'0 1'" -ch_unbounded -periodic -e 10000 -frame_dt TT -o $fig/linear_decay -suppress_output -random_gamma 1 2>/dev/null | tee $fig/txt/linear_stab_logs/stab-$r.txt | grep cmd &
        done
        wait
    )
fi

(
    echo res stab unstab
    for r in $RES ; do
        echo -n $r
        tail -n 1 $fig/txt/linear_stab_logs/stab-$r.txt | sed 's/value://'
    done
) > $fig/txt/linear_stab_logs/summary.txt

cp $ex/linearized_stability_analytic.tex $fig/tex/

(
    cd $fig/tex
    pdflatex -halt-on-error linearized_stability_analytic.tex
    mv linearized_stability_analytic.pdf $fig/pdfs
)

