#!/bin/python3
import os
import subprocess
import concurrent.futures


gammacodes=["gamma=x/(4*pi)+1/2;","gamma=x/(4*pi)*t+1/2;",
        "gamma=(1-2*r)*(x/(2*pi)+1/2)+r;","gamma=t*(1-2*r)*(x/(2*pi)+1/2)+r;",
        "gamma=0.5+1/2.1*cos(x);","0.5+1/2.1*cos(x)*cos(y);","gamma=0.5+1/2.1*cos(x)*(1-sin(t));",
        "gamma=0.5+1/2.1*cos(x)*cos(y)*(1-sin(t));"]


velocitycodes=["u=sin(x)*cos(y)*cos(t);v=-cos(x)*sin(y)*cos(t);p=cos(x)*cos(y)*sin(t);","u=0;v=0;p=0;"]


# varying r; varying b

varyingb=[" -ch_b 0.1 "," -ch_b 0.01 "," -ch_b 0.001 "]
varyingr=[" -ch_min 0.1 "," -ch_min 0.01 "," -ch_min 0.001 ",]

scriptdir="$PROJ/chns_project/example_scripts/"
scripts=[[scriptdir+"paper_tests_non_periodic.sh", scriptdir+"paper_tests_periodic.sh"], [scriptdir+"paper_tests_non_periodic_ch.sh", scriptdir+"paper_tests_periodic_ch.sh"]]

dir="$PROJ/chns_project/example_scripts/meta_script_result/"

checkcollid={}
endframe= " 2 "

commends_to_run=[]

def execute(command): 
    try:
        p = subprocess.Popen(command,shell=True,start_new_session=True,stdout=subprocess.PIPE,stderr=subprocess.PIPE)
        res, errs = p.communicate()
        res += errs
        res = res.decode("utf-8")
    except subprocess.CalledProcessError as e:
        res = e.output + e.stderr + b", failed"
    except Exception as e:
        res = f"unexpected error {e}, failed"
    return res

for ind in range(2):
    for metacmd in scripts[ind]:
        for i in gammacodes:
            code = " \"" + i + velocitycodes[ind] + "\" "
            for j in varyingr:
                for k in varyingb:
                    cmd = metacmd
                    opt = " \"" + j + k + "\" "
                    cmd += " 0 " + endframe + opt + code # 0 means testing optimizor

                    hashval=hash(cmd);
                    hashval=str(hex(hashval))[-8:]
                    if hashval not in checkcollid:
                        checkcollid[hashval] = 1
                    else:
                        print("hashval conflict")
                    print(hashval)
                    curdir=dir+hashval
                    createcurdir="mkdir -p "+curdir+"; "
                    gotodir=" cd "+curdir+"; "
                    getres="; echo \"" + j+k+i+velocitycodes[ind]+ "\" >> ./result.txt; grep -Ir \"\" --include=\"total_summary.txt\" -h >> ./result.txt;"

                    print(createcurdir+gotodir+"nice "+cmd+getres)
                    commends_to_run.append(createcurdir+gotodir+"nice "+cmd+getres)

workers = os.cpu_count()
result = []
print("total threads: ",workers)
with concurrent.futures.ThreadPoolExecutor(max_workers=workers) as executor:
    futures = [executor.submit(execute, cmd) for cmd in commends_to_run]
    print("total jobs: ",len(commends_to_run))
    count = 0
    try:
        for future in concurrent.futures.as_completed(futures):
            count+=1
            print("finished jobs: ", count)
            result.append(future.result())
    except KeyboardInterrupt:
        try:
            futures.terminate()
        except OSError:
            pass

with open(dir+"scriptlog.txt", "w") as fout:
    for line in result:
        fout.write(f"{line}\n")
#print(result)

dir = os.environ.get("PROJ") + "/chns_project/example_scripts/meta_script_result/"
subdirs = os.listdir(dir)
for d in subdirs:
    print("cat "+dir+d+"result.txt >> "+dir+"result.txt")
    os.system("cat "+dir+d+"/result.txt >> "+dir+"result.txt")


# grep -Ir -e "refine 01" -e "L2 order" --include="total_summary.txt" --include="log.txt"

