#! /usr/bin/env bash
#========================================================
# Pressure test suite
# Usage: pressure_tests.sh <fig> [case number=0] [optional argument=none]

# TEST #    type      
#   0       
#   1       
#   2       
#   3       
#   4       
#   5       
#   6       
#========================================================
basedir="$PROJ/chns_project"
ex="$basedir/example_scripts"
sc="$basedir/Figures/scripts"

fig="$1"
mkdir -p $fig/logs $fig/tex $fig/txt $fig/pdfs
shift

test=${1:-1}

CMD="$basedir/chns -test 20 $@ -second_order -mu0 0 -mu1 0 -rho0 1000 -rho1 1000 -dump_st -ch_h_tol 1e-12 -mu_tol 1e-12 -p_tol 1e-12 "

M0=$(perl -e 'print 10**(-5)')
sigma="1"
type=0
offset=0
res=16
dt=0.4 # 0.00025
end_frame=25
steps=100

if [ $test -eq 2 ] 
then
    type=1
elif [ $test -eq 3 ] 
then
    type=2
elif [ $test -eq 4 ] 
then
    type=2
    offset=0.1
elif [ $test -eq 5 ] 
then
    type=2
    offset=0.2
elif [ $test -eq 6 ] 
then
    type=2
    offset=0.3
elif [ $test -eq 7 ] 
then
    type=3
elif [ $test -eq 8 ] 
then
    type=4
elif [ $test -eq 9 ] 
then
    type=5
fi

refine=16
eta0=$(perl -e 'print 4/32')
h=$(perl -e 'print 1/('$res'*'$refine')')
h0=$(perl -e 'print 1/32')
Xeta=$(perl -e 'print 2/3')
XM=$(perl -e 'print 3/2')
eta=$(perl -e 'print '$eta0'*('$h'/'$h0')**'$Xeta)
M=$(perl -e 'print '$M0'*('$eta'/'$eta0')**'$XM)
echo  $CMD -st_type $type -st_offset $offset -ch_sigma $sigma -ch_M $M -ch_eta $eta -frame_dt $dt -e $end_frame -range_max "1 1" -res $res -refine $refine -spf $steps -o $fig/pressure_$test &
$CMD -st_type $type -st_offset $offset -ch_sigma $sigma -ch_M $M -ch_eta $eta -frame_dt $dt -e $end_frame -range_max "1 1" -res $res -refine $refine -spf $steps -o $fig/pressure_$test >/dev/null &


wait
