#! /usr/bin/env bash
#=====================================================
# Rising bubble test with moving contact lines
# A contact line between the water, air, and the top wall appears after the bubble touches the top wal
# Usage rising_bubble_test.sh <fig> [test number=0] [optional argument=none]
#=====================================================
basedir="$PROJ/chns_project"
ex="$basedir/example_scripts"
sc="$basedir/Figures/scripts"

fig="$1"
mkdir -p $fig/logs $fig/tex $fig/txt $fig/pdfs
shift

test=${1:-0}
end_frame=100 # 80000 frames for 2s?
dt=0.000025
option=$2
# use_out=$3

rm -f $fig/tmp-*txt

CMD="$basedir/chns -test 19 -frame_dt $dt -e $end_frame $option -second_order -slip -sigma 1.96"

# density ratio 1000
if [ $test -eq 0 ]
then
    refine=1
    M="1e-7"
    eta=0.1
    echo  $CMD -M $M -eta $eta -rho0 1 -rho1 1000 -range_min "-0.5 0" -range_max "0.5 1.5" -res_v "100 150" -refine $refine -gravity_v "0 -9.8" -o $fig/rising_bubble_$test &
    $CMD -M $M -eta $eta -rho0 1 -rho1 1000 -range_min "-0.5 0" -range_max "0.5 1.5" -res_v "100 150" -refine $refine -gravity_v "0 -9.8" -o $fig/rising_bubble_$test >/dev/null &
    wait
fi

wait
